// VertStat.cpp : implementation file
//

#include "stdafx.h"
#include "BitArr.h"
#include "BitArrDo.h"
#include "BitArrVw.h"
#include "VertStat.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVertStat

CVertStat::CVertStat()
{
}

CVertStat::~CVertStat()
{
}


BEGIN_MESSAGE_MAP(CVertStat, CButton)
	//{{AFX_MSG_MAP(CVertStat)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVertStat message handlers

void CVertStat::DrawItem(LPDRAWITEMSTRUCT lpDIS) 
{
	// TODO: Add your code to draw the specified item
	CDC* pDC = CDC::FromHandle(lpDIS->hDC);
	CWnd* pWnd = CWnd::FromHandle(lpDIS->hwndItem);
	CRect rcRect;
	CFont* pOldFont = pDC->SelectObject(&theApp.m_VertFont);

	pWnd->GetClientRect(rcRect);
	
	CString sStr;
	GetWindowText(sStr);

	int nIndex = GetArrayIndex();
	int nByteIndex = nIndex / 8;
	int nRem = nIndex % 8;
	CString sByte;
	if (!nRem || nRem==7)
	{
		sByte.Format(" (%d)", nByteIndex);
		sStr += sByte;
	}
	else if (nRem == 3)
	{
		int nSize = ((CBitArrView*)GetParent())->m_baArray.GetSize();
		if (nSize && nByteIndex <= nSize/8)
		{
			#ifdef _DEBUG
			sByte.Format("  0x%02X", ((CBitArrView*)GetParent())->m_baArray.GetByteValue(nByteIndex));
			sStr += sByte;
			#endif
		}
	}
	//pDC->TextOut(0, rcRect.bottom, sStr);
	pDC->ExtTextOut(0, rcRect.bottom-2, ETO_CLIPPED|ETO_OPAQUE, rcRect, sStr,NULL);
	if (pOldFont)
	{
		pDC->SelectObject(pOldFont);
	}

	if (!nRem || nRem==7)
	{
		pDC->FrameRect(rcRect, CBrush::FromHandle((HBRUSH)::GetStockObject(BLACK_BRUSH)));
	}
}

int CVertStat::GetArrayIndex() 
{
	char szStr[100];
	int	nIndex;

	GetWindowText(szStr, sizeof(szStr));

	sscanf (szStr, "%d", &nIndex);
	return nIndex;
}
