// BitArrVw.h : interface of the CBitArrView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_BITARRVW_H__428B5122_E717_11D0_8017_00805F9C90EE__INCLUDED_)
#define AFX_BITARRVW_H__428B5122_E717_11D0_8017_00805F9C90EE__INCLUDED_
#include "VertStat.h"
#include "BitArray.h"

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CBitArrView : public CFormView
{
protected: // create from serialization only
	CBitArrView();
	DECLARE_DYNCREATE(CBitArrView)
	
	CVertStat m_xArray[32];
	
	int			m_nArrayStart;
	int			m_nFactor;

public:
	//{{AFX_DATA(CBitArrView)
	enum { IDD = IDD_BITARR_FORM };
	CComboBox	m_xOtherScreens;
	CScrollBar	m_xArrayScroll;
	//}}AFX_DATA
	void SetButtonNumbers();
	void UpdateArrayValues();
	CBitArrView* GetSeletedView();
	void RefreshArrayView();

// Attributes
public:
	CBitArrDoc* GetDocument();
	CBitArray	m_baArray;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBitArrView)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnPrint(CDC* pDC, CPrintInfo*);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CBitArrView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CBitArrView)
	afx_msg void OnBSetSize();
	afx_msg void OnBSetAt();
	afx_msg void OnBArray(UINT nID);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnBSetRange();
	afx_msg void OnBSetAtGrow();
	afx_msg void OnBAdd();
	afx_msg void OnBCopy();
	afx_msg void OnBRefreshScreenNames();
	afx_msg void OnBAppend();
	afx_msg void OnBGoTo();
	afx_msg void OnBSetSerializeFile();
	afx_msg void OnBSave();
	afx_msg void OnBRestore();
	afx_msg void OnBFreeExtra();
	afx_msg void OnBInsertAt();
	afx_msg void OnBInsertAt2();
	afx_msg void OnBRemoveAt();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in BitArrVw.cpp
inline CBitArrDoc* CBitArrView::GetDocument()
   { return (CBitArrDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BITARRVW_H__428B5122_E717_11D0_8017_00805F9C90EE__INCLUDED_)
